set -eu

echo "Loading Keyfork by mnemonic"
export KEYFORKD_SOCKET_PATH=/tmp/keyforkd.sock
( keyfork recover mnemonic & )

while test ! -e $KEYFORKD_SOCKET_PATH; do sleep 1; done

echo "Waiting for inputs from online system..."
while test ! -f /data/input.json; do sleep 1; done

from_address="$(jq -r .from_address /data/input.json)"
to_address="$(jq -r .to_address /data/input.json)"
token_name="$(jq -r .token_name /data/input.json)"
token_amount="$(jq -r .token_amount /data/input.json)"

jq . /data/input.json
echo "Do these values look correct? If not, press ctrl-c. Otherwise, press Enter."
read -r _

echo "Creating and signing transaction"

icepick workflow sol transfer-token --from-address "$from_address" --to-address "$to_address" --token-name "$token_name" --token-amount "$token_amount"
